#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <cutil.h>

#include "cconfig.h"
#include "cgpu_config.h"
#include "cgpu_block_solver_config.h"
#include "../GPUSolverClass/cudaTimer.h"
#include "cuparam-size.h"
#include "flop_table.h"

//
// define _DEBUG_ to print out the residual history.
//
//#define _DEBUG_
#undef _DEBUG_

//
// Fortran module vars
// 
#include "cufortran_vars.h"
#undef _multiter_
#define _multiter_  (cu_mult_count[3])


namespace gpu4 {

#define __NEW_GPU_SOLVER      new_gpu_solver_g4
#define __DELETE_GPU_SOLVER   delete_gpu_solver_g4
#define __S_BICGSTAB_HMC_GPU  bicgstab_g4
#define __S_CG_HMC_GPU        cg_g4
#define __INV_MULT_INV_OEE_CG_GPU  assign_inv_mult_Oee_g4
#define __TEST_MULT           test_mult_g4

#include "main_gpu_solver.h"

}
