#ifndef _FLOP_TABLE_H
#define _FLOP_TABLE_H

#define MULT_CLOVER          (600)
#define MULT_WD_CLV          (1896)
#define MULT_MB_PRE_CLV      (1896*2+48)
#define MULT_WD_WIL          (1896-600)
#define MULT_MB_PRE_WIL      ((1896-600)*2+48)

#ifdef _CLOVER
#define MULT_WD              (1896)
#define MULT_MB_PRE          (1896*2+48)
#else
#define MULT_WD              (1896-600)
#define MULT_MB_PRE          ((1896-600)*2+48)
#endif

#define QMULT2C_ACCUM_ADD    (96)
#define QMULT1C_ACCUM_ADD    (96)

#define QACCUM_MULTC_ADD     (48*2)
#define QACCUM_MULTR_ADD     (48)
#define QACCUM_ADD_MULTC     (48*2)
#define QACCUM_SUB_MULTC     (48*2)
#define QACCUM_ADD_MULTR     (48)
#define QACCUM_SUB_MULTR     (48)
#define QACCUM_ADD           (24)
#define QACCUM_SUB           (24)
#define QPROD                (100)
#define QABS2                (49)
#define QMULTR               (24)

#endif
